﻿Imports System.Array
Imports System.Text
Imports System.Text.RegularExpressions

Module Module1
    Public Sub Main(ByVal args() As String)
        ' Test string
        Dim fileName = "C:\win.txt"

        ' Test string concatenation
        Dim s1 As String = "Al"
        Dim s2 As String = "oha"
        Dim greeting As String = s1 & s2
        Console.WriteLine(greeting)

        Dim x1 As String = "Al"
        Dim x2 As String = "oha"
        Dim hello As String = String.Concat(x1, x2)
        Console.WriteLine(hello)

        ' Compare strings
        Dim a As String = ".NET is cool"
        Dim b As String = a
        If a = b Then
            Console.WriteLine("Yes, a and b are referring to the same object")
        End If

        ' string literals
        Dim s3 As String = "Strings " & "are important"
        Dim s4 As String = "This is an important " &
                "point to note"
        Dim s5 As String = "String number " & 3
        Console.WriteLine(s5)

        ' Special characters
        Dim s6 = "Line 1" & vbNewLine & "Line 2"
        Console.WriteLine(s6)

        Dim s7 As String = ControlChars.Tab & "10. Please ..."
        Console.WriteLine(s7)
        Dim s8 As String = "John ""The Great"" Monroe"
        Console.WriteLine(s8)

        ' String class's Chars property
        Dim greeting2 As String = "Welcome"
        Dim firstChar As Char = greeting2.Chars(0)
        Console.WriteLine(firstChar)

        Dim greeting3 As String = "Hello"
        For i = 0 To greeting3.Length - 1
            Console.WriteLine(greeting3.Chars(i))
        Next

        ' Concat method
        Dim s9 = String.Concat("Hello", "World", 2, "!")
        Console.WriteLine(s9)

        Console.WriteLine(".NET is cool".IndexOf("cool"))
        Console.WriteLine(".Net is cool".Substring(5, 2))

        Console.WriteLine("dingdong".Replace("d"c, "k"c))

        ' StringBuilder
        Dim s10 = "Hello World"
        Dim builder = New StringBuilder(s10, 6, 5, 20)
        Console.WriteLine(builder)

        Dim builder4 = New StringBuilder("Kingkong")
        builder4(0) = "P"
        builder4(4) = "S"
        Console.WriteLine(builder4)

        Dim sb = New StringBuilder("Hi Hello")
        sb.Append("World").Insert(8, " ").Remove(0, 3)
        Console.WriteLine(sb.ToString()) ' print "Hello World"

        ' array
        Dim ints As Integer() = New Integer(4) {}

        Dim names(4) As String
        names(0) = "Hello World" 'assign value to first element of names

        Dim names4 = New String() {"John", "Mary", "Paul"}
        Dim numbers = New Integer() {1, 2, 3}
        Dim avg = Average(numbers)

        Dim employees = New String() {"John", "Paul", "George", "Ringo"}
        For Each employee In employees
            Console.WriteLine("Employee:" + employee) ' print employee
        Next

        For i = 0 To employees.Length - 1
            Console.WriteLine("Employee:" & employees(i))
        Next


        Dim friends = New String() {"John", "Paul", "George", "Ringo"}
        'Resize the array
        ReDim Preserve friends(5)     'assign array new size
        ' friend is a keyword, but we really like to use it as a variable
        ' name because it's so appropriate, so we put it in square brackets
        For Each [friend] In friends
            Console.WriteLine("Friend:" + [friend])
        Next

        For Each arg In args
            Console.WriteLine(arg)
        Next

        Console.ReadKey()
    End Sub

    Public Sub sampleGetChar()
        Dim greeting As String = "Welcome"
        Dim firstChar As Char = greeting.Chars(0)
        Console.WriteLine(firstChar)
        Console.WriteLine()

        Dim greeting2 As String = "Hello"
        For i = 0 To greeting2.Length - 1
            Console.WriteLine(greeting2.Chars(i))
        Next
    End Sub

    Public Sub sampleEscapeCharacter()
        Dim s As String = "Please type this character \u0122"
        Console.WriteLine(Regex.Unescape(s))

        Dim s2 As String = "John ""The Great"" Monroe"
        Console.WriteLine(s2)
    End Sub

    Public Sub sampleStringBuilder()
        'Get and Set a Character to a StringBuilder
        Dim builder4 = New StringBuilder("Kingkong")

        Console.WriteLine("First Char before change: " + builder4(0))

        builder4(0) = "S"
        builder4(4) = "C"
        Console.WriteLine(builder4.ToString)  'print SingCong
        Console.WriteLine()

        'Append, Insert and Remove
        Dim sb = New StringBuilder("Hi Hello")
        sb.Append("World").Insert(8, " ").Remove(0, 3)
        Console.WriteLine(sb.ToString()) ' print "Hello World"

        Dim employees = New String() {"John", "Paul", "George", "Ringo"}
        For Each employee In employees
            Console.WriteLine("Employee:" + employee) ' print employee
        Next

        Dim length = employees.Length - 1
        For i = 0 To length
            Console.WriteLine("Employee:" & employees(i))
        Next

        'Resize the array
        ReDim Preserve employees(10)     'assign array new size
        Console.WriteLine("Employee1 after Redim Preserve: " & employees(0))  'keep the value
        Console.WriteLine("Length: " & employees.Length)   'length is 11 (0..10)
        Console.WriteLine("UpperBound: " & employees.GetUpperBound(0))  '10

        Array.Resize(employees, 11)  'assign array new length
        Console.WriteLine("Employee1 after resize: " & employees(0))     'retain value
        Console.WriteLine("Length: " & employees.Length)   'length is 11 
        Console.WriteLine("UpperBound: " & employees.GetUpperBound(0))  '10 (0..10)

        ReDim employees(8)
        Console.WriteLine("Employee1 after Redim: " & employees(0))  'old value is discarded
        Console.WriteLine("Length: " & employees.Length)
        Console.WriteLine("UpperBound: " & employees.GetUpperBound(0))


    End Sub

    Public Sub sampleArray()
        'Check names null
        Dim names As String()
        If (names Is Nothing) Then Console.WriteLine("names is null")

        'Several ways to declare and initilize the array
        Dim names1() As String
        names1 = New String(2) {}
        If (names1 Is Nothing) Then
            Console.WriteLine("names1 is null")
        Else
            Console.WriteLine("names1 is not null and length is " & names1.Length)
        End If

        Dim names2(4) As String
        names2(0) = "Hello World" 'assign value to first element of names
        Console.WriteLine(names2(0))

        Dim names3 = New String(4) {}
        names3(1) = "Hello Again"
        Console.WriteLine(names3(1))

        Dim names4 = New String() {"John", "Mary", "Paul"}
        Console.WriteLine(names4(1))

        Dim matrix() As Integer = {1, 2, 3, 10}
        Console.WriteLine("Matrix position 1: " & matrix(1))

        '2 dimensional array
        Dim box(2, 2) As Integer
        box(0, 0) = 1
        Console.WriteLine("Box's contain in row 0 col 0 is " & box(0, 0))

        Dim box2 = {{1, 2}, {3, 4}}
        Console.WriteLine("Box's contain in row 1 col 0 is " & box2(1, 0))

        'Passing array to a method
        Dim avg As Integer
        avg = Average(New Integer() {1, 2, 3})
        Console.WriteLine("Average: " & avg)

        Dim numbers = New Integer() {1, 2, 3}
        Average(numbers)

        'Iterating through array
    End Sub

    Public Function Average(ByVal numbers() As Integer) As Double
        Dim total As Long
        Dim arrayCount As Integer = numbers.GetUpperBound(0)

        'Loop through array
        For index = 0 To arrayCount
            total = total + numbers(index)
        Next

        Return (total / numbers.Length)

    End Function
End Module

